---
title: WritableStreamDefaultController
slug: Web/API/WritableStreamDefaultController
tags:
  - API
  - Experimental
  - Fetch
  - Interface
  - Reference
  - Streams
  - WritableStreamDefaultController
---
<p>{{SeeCompatTable}}{{APIRef("Streams")}}</p>

<p>The <strong><code>WritableStreamDefaultController</code></strong> interface of the <a href="/en-US/docs/Web/API/Streams_API">Streams API</a> represents a controller allowing control of a {{domxref("WritableStream")}}'s state. When constructing a <code>WritableStream</code>, the underlying sink is given a corresponding <code>WritableStreamDefaultController</code> instance to manipulate.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dd>None. <code>WritableStreamDefaultController</code> instances are created automatically during <code>WritableStream</code> construction.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p>None.</p>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("WritableStreamDefaultController.error()")}}</dt>
 <dd>Causes any future interactions with the associated stream to error.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">const writableStream = new WritableStream({
  start(controller) {
    // do stuff with controller

    // error stream if necessary
    controller.error('My stream is broken');
  },
  write(chunk, controller) {
    ...
  },
  close(controller) {
    ...
  },
  abort(err) {
    ...
  }
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Streams','#ws-default-controller-class','WritableStreamDefaultController')}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.WritableStreamDefaultController")}}</p>
</div>
